"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformClassBody = void 0;
const t = __importStar(require("@babel/types"));
const convertFunctionTypeAnnotation_1 = require("../converters/convertFunctionTypeAnnotation");
function transformClassBody(path) {
    for (const elementPath of path.get('body')) {
        if (elementPath.isClassMethod()) {
            // todo:
            ///transformFunctionParams(elementPath.get('params'));
        }
        const node = elementPath.node;
        if (t.isClassProperty(node)) {
            if (node.readonly) {
                // @ts-ignore todo: @babel/types
                node.variance = t.variance('plus');
                node.readonly = null;
            }
        }
        if (t.isTSDeclareMethod(node)) {
            // todo: might be not used
            const { typeParams, parameters, rest, returnType } = convertFunctionTypeAnnotation_1.convertFunctionTypeAnnotation(node);
            let key;
            if (t.isIdentifier(node.key)) {
                key = t.identifier(node.key.name);
            }
            else if (t.isStringLiteral(node.key)) {
                key = node.key;
            }
            else {
                throw new Error('todo:');
            }
            const replacement = t.objectTypeProperty(key, t.functionTypeAnnotation(typeParams, parameters, rest, returnType ? returnType : t.anyTypeAnnotation()));
            if (node.kind === 'get' || node.kind === 'set') {
                replacement.kind = node.kind;
            }
            else {
                replacement.kind = 'init';
            }
            // @ts-expect-error todo: @babel/types
            replacement.static = node.static;
            replacement.optional = !!node.optional;
            replacement.method = true;
            elementPath.replaceWith(replacement);
        }
    }
}
exports.transformClassBody = transformClassBody;
//# sourceMappingURL=transformClassBody.js.map