"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformClassDeclaration = void 0;
const t = __importStar(require("@babel/types"));
const convertTSTypeParameterInstantiation_1 = require("../converters/convertTSTypeParameterInstantiation");
const convertTSEntityName_1 = require("../converters/convertTSEntityName");
const convertTSTypeParameterDeclaration_1 = require("../converters/convertTSTypeParameterDeclaration");
const transformClassBody_1 = require("./transformClassBody");
const replaceWith_1 = require("../utils/replaceWith");
const convertClassTypeDeclaration_1 = require("../converters/convertClassTypeDeclaration");
const converted = new WeakSet();
function transformClassDeclaration(path, isAmbientContext) {
    const node = path.node;
    if (converted.has(node)) {
        return;
    }
    converted.add(node);
    if (node.declare || isAmbientContext) {
        replaceWith_1.replaceWith(path, convertClassTypeDeclaration_1.convertClassTypeDeclaration(node));
        return;
    }
    if (t.isTSTypeParameterInstantiation(node.superTypeParameters)) {
        const superTypeParameters = path.get('superTypeParameters');
        superTypeParameters.replaceWith(convertTSTypeParameterInstantiation_1.convertTSTypeParameterInstantiation(node.superTypeParameters));
    }
    if (node.implements) {
        const impls = path.get('implements');
        for (const impl of impls) {
            const id = convertTSEntityName_1.convertTSEntityName(impl.node.expression);
            const typeParameters = impl.node.typeParameters
                ? convertTSTypeParameterInstantiation_1.convertTSTypeParameterInstantiation(impl.node.typeParameters)
                : null;
            if (!t.isIdentifier(id)) {
                throw new Error('todo: welcome to flow - support qualified identifiers in implements are not supported');
            }
            impl.replaceWith(t.classImplements(id, typeParameters));
        }
    }
    if (node.typeParameters &&
        t.isTSTypeParameterDeclaration(node.typeParameters)) {
        path.get('typeParameters').replaceWith(convertTSTypeParameterDeclaration_1.convertTSTypeParameterDeclaration(node.typeParameters));
    }
    // todo @babel/types
    transformClassBody_1.transformClassBody(path.get('body'));
}
exports.transformClassDeclaration = transformClassDeclaration;
//# sourceMappingURL=transformClassDeclaration.js.map